import 'package:flutter_vasat/models/vasat_model.dart';

class User extends VasatModel<User> {

  String? email;
  String? name;
  String? username;

  User({Map<String, dynamic>? json}) {
    fromJson(json);
  }

  factory User.fromJson(Map<String, dynamic> json) {
    return User(json:json);
  }

  @override
  fromJsonItem(Map<String, dynamic>? json) {
    if (json != null) {
      email = json['email'];
      name = json['name'];
      username = json['username'];
    }
  }


  @override
  Map<String, dynamic> toJson() {
    return {
    "email": email,
    "username": username,
    "name": name,
    };
  }

  @override
  User copyFromJson(Map<String, dynamic> json) {
    return User.fromJson(json);
  }


}