abstract class VasatModel<T> {

  String? id;
  String? displayName;
  int? dateMade;
  int? dateUpdated;
  List<String>? acl;
  bool? dirty;


  fromJson(Map<String, dynamic>? json) {
    if (json != null) {
      id = json['id'];
      displayName = json['displayName'];
      dateMade = json['dateMade'];
      dateUpdated = json['dateUpdated'];
      // Object specific fields. As Vasat allows for inline fields we simply check if we have the item field. If we do use it. Otherwise assume all object fields are inline
      fromJsonItem( (json['item'] != null) ? json['item'] : json);
    }
  }

  Map<String, dynamic> toJson();

  fromJsonItem(Map<String, dynamic>? json);

  /// This is so we can dynamically create objects from generic types. DART does not support generic constructor so we do this.
  T copyFromJson(Map<String, dynamic> json);
}